
//  EnumTests.java  Copyright (c) 2005 Kari Laitinen

//  http://www.naturalprogramming.com

//  2005-05-09   File created.
//  2005-05-27   Last modification.

import java.util.* ;



enum  TimeOfYear
{
   WINTER( 1 ),
   SPRING( 4 ),
   SUMMER( 7 ),
   AUTUMN( 10 ),
   FALL  ( 10 );

   int beginning_month ;

   TimeOfYear( int given_month )
   {
      beginning_month  =  given_month ;
   }
}


enum DayOfWeek
{
   Monday   ( "lunes" ),
   Tuesday  ( "martes" ),
   Wednesday( "miercoles" ),
   Thursday ( "jueves" ),
   Friday   ( "viernes" ),
   Saturday ( "sabado" ),
   Sunday   ( "domingo" ) ;

   String  spanish_day_of_week ;

   DayOfWeek( String given_spanish_day_of_week )
   {
      spanish_day_of_week  =  given_spanish_day_of_week ;
   }

   public String toString()
   {
      return ( name() + " (" + spanish_day_of_week + ")" ) ;
   }
}

enum SpanishDayOfWeek
{
   Lunes,
   Martes,
   Miercoles,
   Jueves,
   Viernes,
   Sabado,
   Domingo 
}

enum Status
{
   SEARCH_NOT_READY,
   SEARCH_IS_READY,
   SEARCH_IS_SUCCESSFUL,
   SEARCH_NOT_SUCCESSFUL
}

/*  My understanding is that, when an enum constant like
    SpanishDayOfWeek.Miercoles is concatenated to a string
    with the operator +, the constant is first converted to
    an Enum object in an automatic (implicit) boxing
    operation, and then the ToString() method is invoked
    for the boxed enum value. The ToString() of class Enum
    works so that in returns a String that contains the
    constant name as a string.  */

class EnumTests
{
   public static void main( String[] not_in_use )
   {
      SpanishDayOfWeek  some_day  =  SpanishDayOfWeek.Domingo ;

      System.out.print( "\n The day value is "  +  some_day ) ; 

      System.out.print( " and its number is "  +  some_day.ordinal() ) ;

      String  some_string  =  "zzzzz "  +  SpanishDayOfWeek.Miercoles ;

      System.out.print( "\n "  +  some_string ) ;

      //  values() method is automatically generated for an enum.
      //  Unlike method ordinal(), it is not mentioned in class Enum.

      for ( Status current_status : Status.values() )
      {

         System.out.print( "\n The Status value "  +  current_status
                        +  "  has number  "  +  current_status.ordinal() ) ;
      }


      System.out.print( "\n\n DayOfWeek.Monday as string is "
                     +  DayOfWeek.Monday ) ;

   }
}



